#include <stdio.h>
#include <errno.h>
#include <sys/file.h>

int main (int argc, char *argv[])
{
    struct flock lck;
    int          fd;

    if (   argc < 3
        || (strcmp (argv[1], "1") && strcmp (argv[1], "2"))) {
        fprintf (stderr, "Missing argument\n");
        fprintf (stderr, "Usage: %s <1|2> <filename>\n", argv[0]);
        fprintf (stderr, "1=BSD   flock\n");
        fprintf (stderr, "2=POSIX fcntl\n");
        exit (1);
    }

    fd = open (argv[2], O_RDWR | O_CREAT, 00744);
    if (fd == -1 && errno == ENOENT) {
        perror ("open");
        exit (1);
    }
    if (strcmp (argv[1], "1") == 0) {
        printf ("Trying BSD flock (\"%s\", LOCK_EX)...\n", argv[2]);
        if (flock (fd, LOCK_EX) != 0) {
            perror ("fcntl");
            exit (1);
        }
        printf ("BSD flock lock acquired\n");
    } else {
        printf ("Trying POSIX fcntl (\"%s\", F_SETLKW, F_WRLCK)...\n", argv[2]);

        lck.l_type   = F_WRLCK;
        lck.l_whence = SEEK_SET;
        lck.l_start  = 0;
        lck.l_len    = 0;

        if (fcntl (fd, F_SETLKW, &lck) != 0) {
            perror ("fcntl");
            exit (1);
        }
        printf ("POSIX fnctl lock acquired\n");
    }
}
